
    /*!
    * structured-editor v0.1.3
    * (c) 2019 HollyIT (limited liability)
    * @license MIT
    */
  
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prosemirror-state'), require('prosemirror-utils'), require('Editable.vue?rollup-plugin-vue=script.js'), require('vue-runtime-helpers/dist/normalize-component.js'), require('@ledecmf/structured-editor-extensions'), require('@ledecmf/structured-editor-ui'), require('StructuredEditor.vue?rollup-plugin-vue=script.js'), require('vue-runtime-helpers/dist/inject-style/browser.js')) :
  typeof define === 'function' && define.amd ? define(['exports', 'prosemirror-state', 'prosemirror-utils', 'Editable.vue?rollup-plugin-vue=script.js', 'vue-runtime-helpers/dist/normalize-component.js', '@ledecmf/structured-editor-extensions', '@ledecmf/structured-editor-ui', 'StructuredEditor.vue?rollup-plugin-vue=script.js', 'vue-runtime-helpers/dist/inject-style/browser.js'], factory) :
  (global = global || self, factory(global.structuredEditor = {}, global.prosemirrorState, global.prosemirrorUtils, global.script, global.__vue_normalize__, global.structuredEditorExtensions, global.structuredEditorUi, global.script$1, global.__vue_create_injector__));
}(this, function (exports, prosemirrorState, prosemirrorUtils, script, __vue_normalize__, structuredEditorExtensions, structuredEditorUi, script$1, __vue_create_injector__) { 'use strict';

  var script__default = 'default' in script ? script['default'] : script;
  __vue_normalize__ = __vue_normalize__ && __vue_normalize__.hasOwnProperty('default') ? __vue_normalize__['default'] : __vue_normalize__;
  var script$1__default = 'default' in script$1 ? script$1['default'] : script$1;
  __vue_create_injector__ = __vue_create_injector__ && __vue_create_injector__.hasOwnProperty('default') ? __vue_create_injector__['default'] : __vue_create_injector__;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  /**
   * @typedef {import('prosemirror-view').EditorView} EditorView
   * @typedef {import('prosemirror-state').EditorState} EditorState
   */

  var SelectionEvent =
  /*#__PURE__*/
  function () {
    /**
     *
     * @param {EditorView} view
     * @param {EditorState} lastState
     */
    function SelectionEvent(view, lastState) {
      _classCallCheck(this, SelectionEvent);

      /**
       * @type {EditorView}
       * @public
       */
      this.view = view;
      this.lastState = lastState;
      this._parentNodes = null;
      this._parentNode = null;
      this._box = null;
    }
    /**
     *
     * @param type
     * @returns {boolean}
     */


    _createClass(SelectionEvent, [{
      key: "in",
      value: function _in(type) {
        return prosemirrorUtils.hasParentNode(function (node) {
          return node.type.name === type;
        })(this.selection);
      }
      /**
       *
       * @returns {Selection<S>}
       */

    }, {
      key: "selection",
      get: function get() {
        return this.view.state.selection;
      }
      /**
       *
       * @returns {*}
       */

    }, {
      key: "node",
      get: function get() {
        return this.selection.node;
      }
      /**
       *
       * @returns {boolean}
       */

    }, {
      key: "empty",
      get: function get() {
        return this.selection.empty;
      }
      /**
       *
       * @returns {EditorState<S>}
       */

    }, {
      key: "state",
      get: function get() {
        return this.view.state;
      }
      /**
       *
       * @returns {Array.<Node>}
       */

    }, {
      key: "parentNodes",
      get: function get() {
        if (this._parentNodes) {
          return this._parentNodes;
        }

        var _this$state$selection = this.state.selection,
            $from = _this$state$selection.$from,
            from = _this$state$selection.from,
            to = _this$state$selection.to;
        this._parentNodes = [];

        for (var i = $from.depth; i > 0; i--) {
          var node = $from.node(i);

          if (node && !this._parentNode) {
            this._parentNode = node;
          }

          this._parentNodes.push(node);
        }

        return this._parentNodes;
      }
      /**
       *
       * @returns {Node}
       */

    }, {
      key: "parentNode",
      get: function get() {
        if (!this._parentNodes) {
          this.parentNodes;
        }

        return this._parentNode;
      }
      /**
       *
       * @returns {string}
       */

    }, {
      key: "type",
      get: function get() {
        if (this.selection instanceof prosemirrorState.TextSelection) {
          return 'text';
        }

        if (this.selection instanceof prosemirrorState.NodeSelection) {
          return 'node';
        }
      }
    }, {
      key: "box",
      get: function get() {
        if (!this._box) {
          var _this$selection = this.selection,
              $from = _this$selection.$from,
              from = _this$selection.from,
              to = _this$selection.to;
          var start = this.view.coordsAtPos(from);
          var end = this.view.coordsAtPos(to);
          this._box = {
            start: start,
            end: end
          };
        }

        return this._box;
      }
    }, {
      key: "parentElement",
      get: function get() {}
    }]);

    return SelectionEvent;
  }();

  /* script */
  const __vue_script__ = script__default;

  /* template */
  var __vue_render__ = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c(_vm.wrapper, {
      ref: "input",
      tag: "component",
      staticClass: "lede-editable",
      class: { "is-empty": _vm.isEmpty },
      attrs: { contenteditable: _vm.editable, placeholder: _vm.placeholder },
      domProps: { textContent: _vm._s(_vm.input) },
      on: {
        focus: function($event) {
          return _vm.$emit("focus")
        },
        input: _vm.doUpdate,
        blur: function($event) {
          return _vm.$emit("blur")
        },
        paste: _vm.onPaste,
        keydown: _vm.checkKey
      }
    })
  };
  var __vue_staticRenderFns__ = [];
  __vue_render__._withStripped = true;

    /* style */
    const __vue_inject_styles__ = undefined;
    /* scoped */
    const __vue_scope_id__ = undefined;
    /* module identifier */
    const __vue_module_identifier__ = undefined;
    /* functional template */
    const __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    

    
    var Editable = __vue_normalize__(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      undefined,
      undefined
    );

  var ConfigCollection =
  /*#__PURE__*/
  function () {
    function ConfigCollection(keyProp) {
      _classCallCheck(this, ConfigCollection);

      this._keyProp = keyProp;
      this._items = [];
    }

    _createClass(ConfigCollection, [{
      key: "all",
      value: function all() {
        return this._items;
      }
    }, {
      key: "has",
      value: function has(key) {
        return !!this.get(key);
      }
    }, {
      key: "get",
      value: function get(key) {
        var _this = this;

        return this._items.find(function (item) {
          return item[_this._keyProp] === key;
        });
      }
    }, {
      key: "add",
      value: function add(object) {
        this._items.push(object);

        return this;
      }
    }, {
      key: "getIndex",
      value: function getIndex(key) {
        var _this2 = this;

        this._items.findIndex(function (item) {
          return item[_this2._keyProp] === key;
        });
      }
    }, {
      key: "replace",
      value: function replace(key, object) {
        var idx = this.getIndex(key);

        if (idx > -1) {
          this._items[idx] = object;
          return true;
        } else {
          return false;
        }
      }
    }, {
      key: "remove",
      value: function remove(key) {
        var idx = this.getIndex(key);

        if (idx > -1) {
          this._items.splice(idx, 1);

          return true;
        } else {
          return false;
        }
      }
    }]);

    return ConfigCollection;
  }();

  var ExtensionCollection =
  /*#__PURE__*/
  function (_ConfigCollection) {
    _inherits(ExtensionCollection, _ConfigCollection);

    function ExtensionCollection() {
      _classCallCheck(this, ExtensionCollection);

      return _possibleConstructorReturn(this, _getPrototypeOf(ExtensionCollection).call(this, 'name'));
    }

    _createClass(ExtensionCollection, [{
      key: "all",
      value: function all() {
        var _this = this;

        this._items.forEach(function (item) {
          if (item.dependencies) {
            item.dependencies.forEach(function (dep) {
              if (!_this.has(dep.name)) {
                _this.add(dep);
              }
            });
          }
        });

        return this._items;
      }
    }]);

    return ExtensionCollection;
  }(ConfigCollection);

  /**
   * @property { ConfigCollection } extensions
   * @property {ConfigCollection } plugins
   */

  var EditorConfiguration =
  /**
   *
   */
  function EditorConfiguration() {
    _classCallCheck(this, EditorConfiguration);

    this.extensions = new ExtensionCollection();
    this.extensions.add(new structuredEditorExtensions.Doc()).add(new structuredEditorExtensions.Paragraph()).add(new structuredEditorExtensions.Text());
    this.plugins = new ConfigCollection('name');
    this.selectionMenu = new structuredEditorUi.EditorMenu();
    this.blockMenu = new structuredEditorUi.EditorMenu();
    this.insertMenu = new structuredEditorUi.InsertMenuCollection();
  };

  /* script */
  const __vue_script__$1 = script$1__default;

  /* template */
  var __vue_render__$1 = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c(
      "div",
      {
        staticClass: "lede-structured-editor",
        class: { "has-focus": _vm.hasFocus, "menu-mode": _vm.showMenu }
      },
      [
        _vm.tiptap
          ? [
              _vm.showMenu
                ? [
                    _c("menu-bar", {
                      attrs: {
                        config: _vm.config,
                        editor: _vm.tiptap,
                        settings: _vm.menuSettings
                      }
                    })
                  ]
                : [
                    _c("selection-menu", {
                      attrs: {
                        editor: _vm.tiptap,
                        menu: _vm.config.selectionMenu
                      }
                    }),
                    _vm._v(" "),
                    _c("block-menu", {
                      attrs: { editor: _vm.tiptap, menu: _vm.config.blockMenu }
                    }),
                    _vm._v(" "),
                    _c("insert-menu", {
                      attrs: { editor: _vm.tiptap, menu: _vm.config.insertMenu }
                    })
                  ],
              _vm._v(" "),
              _c("editor-content", { attrs: { editor: _vm.tiptap } })
            ]
          : _vm._e()
      ],
      2
    )
  };
  var __vue_staticRenderFns__$1 = [];
  __vue_render__$1._withStripped = true;

    /* style */
    const __vue_inject_styles__$1 = function (inject) {
      if (!inject) return
      inject("data-v-378fd27b_0", { source: "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n", map: {"version":3,"sources":[],"names":[],"mappings":"","file":"StructuredEditor.vue"}, media: undefined });

    };
    /* scoped */
    const __vue_scope_id__$1 = "data-v-378fd27b";
    /* module identifier */
    const __vue_module_identifier__$1 = undefined;
    /* functional template */
    const __vue_is_functional_template__$1 = false;
    /* style inject SSR */
    

    
    var StructuredEditor = __vue_normalize__(
      { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
      __vue_inject_styles__$1,
      __vue_script__$1,
      __vue_scope_id__$1,
      __vue_is_functional_template__$1,
      __vue_module_identifier__$1,
      __vue_create_injector__,
      undefined
    );

  exports.Editable = Editable;
  exports.EditorConfiguration = EditorConfiguration;
  exports.SelectionEvent = SelectionEvent;
  exports.default = StructuredEditor;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
